;
;
; ==================================================
;
;   Ana_308.asm     Axiom M68EVB08GB60 
;                                 
;   Version:        1.0   Released 03/03/2003
;   Author:         Gary Karnes , Axiom Mfg.
;   Compiler:       HC08
;       
;   Platform:       Axiom M68EVB08GB60 AXM-0308
;   Purpose:        Analog Subroutines
; ==================================================
;
;
; 
; Analog Selftest
; This subroutine will test the analog port
; This uses a header installed in the analog
; port with 1k resistors between VRH to each 
; analog channel then to VRL
;
; Normal reading in hx
;    Ch0  = $020D
;    Ch1  = $01F2
;    Ch2  = $022A
;    Ch3  = $01D7
;    Ch4  = $02C8
;    Ch5  = $00E4
;    Ch6  = $0366
;    Ch7  = $009D
;
;================================================
;
Ana_308:
            mov   #$ff,ADPE       ; set port for A/D 
            mov   #$20,ADSC       ; start conversion
            jsr   Sci1Str3
            fdb   MCRLF
            fdb   MCRLF
            fdb   MCRLF
            jsr   Sci1Str3
            fdb   MAnalog         ; Analog Self Test
            fdb   MSelf
            fdb   MTest
            jsr   Sci1Str1
            fdb   MCRLF
            jsr   Sci1Str3
            fdb   MInstall        ; Install Test Connector
            fdb   MTest
            fdb   MConnect
            jsr   Sci1Str3
            fdb   MOn             ; on Analog Port
            fdb   MAnalog
            fdb   MPort
            jsr   Sci1Str1
            fdb   MCRLF
            jsr   PKey            ; press any key
;            jsr   Input
            
;
; Start Checking Analog Channel
; Check Channel zero 
;
           
            jsr   Ana308_0        ; read channel zero
            cphx  #$01D0          ; lower limit
            blo   Ana308_F        ; report fail
            cphx  #$0250          ; upper limit
;            bhi   Ana308_F

; Check Channel one
            jsr   Ana308_1        ; read channel one
            cphx  #$0170          ; 
            blo   Ana308_F        ; report fail
            cphx  #$0240          ; upper limit
;            bhi   Ana308_F
; Check Channel two
            jsr   Ana308_2        ; read channel two
            cphx  #$01E0          ; 
            blo   Ana308_F  
            cphx  #$0270          ; upper limit
;            bhi   Ana308_F      
; Check Channel three
            jsr   Ana308_3        ; read channel three
            cphx  #$0140          ; 
            blo   Ana308_F
            cphx  #$0230          ; upper limit
;            bhi   Ana308_F
; Check Channel four
            jsr   Ana308_4        ; read channel four
            cphx  #$0240          ; 
            blo   Ana308_F
            cphx  #$0320          ; upper limit
;            bhi   Ana308_F
; Check Channel five
            jsr   Ana308_5        ; read channel five
            
; Test
            pshx
            pshh
            pula
            jsr    HEX2
            pula
            jsr    HEX2
; Test

            cphx  #$00B0          ; 
            blo   Ana308_F
            cphx  #$0180          ; upper limit
;            bhi   Ana308_F
; Check Channel six
            jsr   Ana308_6        ; read channel six
            cphx  #$0300          ; 
;            blo   Ana308_F
            cphx  #$03B0          ; upper limit
;            bhi   Ana308_F
; Check Channel seven
            jsr   Ana308_7        ; read channel seven
            cphx  #$0050          ; 
;            blo   Ana308_F
            cphx  #$00F0          ; upper limit
;            bhi   Ana308_F
;
            jsr   Passed          ; report Passed
             rts    
;
;
; Report Fail
Ana308_F:
            jsr    Failed
            rts

;
;  Analog Subroutines
;  
;  Ana_308   = Does a Self Test on the analog channels
;  Ana308_0  =  read analog channel zero
;  Ana308_1  =   "      "     "     one
;  Ana308_2  =   "      "     "     two 
;  Ana308_3  =   "      "     "     three
;  Ana308_4  =   "      "     "     four
;  Ana308_5  =   "      "     "     five
;  Ana308_6  =   "      "     "     six
;  Ana308_7  =   "      "     "     seven
;
;[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
;
;
;
; Read Channel 0  
Ana308_0:
           mov    #$20,ADSC   ; select channel zero
           bra    Ana308R      ; read results and return
;
;
; Read Channel 1  
Ana308_1:
           mov    #$21,ADSC   ; select channel one
           bra    Ana308R      ; read results and return
;
;
; Read Channel 2  
Ana308_2:
           mov    #$22,ADSC   ; select channel two
           bra    Ana308R      ; read results and return
;
;
; Read Channel 3  
Ana308_3:
           mov    #$23,ADSC   ; select channel three
           bra    Ana308R      ; read results and return
;
;
; Read Channel 4  
Ana308_4:
           mov    #$24,ADSC   ; select channel four
           bra    Ana308R      ; read results and return
;
;
; Read Channel 5  
Ana308_5:
           mov    #$25,ADSC   ; select channel five
           bra    Ana308R      ; read results and return
;
;
; Read Channel 6  
Ana308_6:
           mov    #$26,ADSC   ; select channel six
           bra    Ana308R      ; read results and return
;
;
; Read Channel 7  
Ana308_7:
           mov    #$27,ADSC   ; select channel seven
           bra    Ana308R      ; read results and return
;

;
; Read results and return
Ana308R:
            bsr    Ana308D     ; wait for convertion 
            bsr    Ana308D      
            ldhx   ADRH
            rts
;
; Delay for convertion
Ana308D:
            psha              ; save a
            lda    #$ff       ; delay value
Ana308DL:
            dbnza  Ana308DL   ; repeat until done 
            pula              ; restore a
            rts
;
;
;
;