;
; ===========================================================================
;
;   Hex_308.asm     Axiom M68EVB08GB60 
;                                 
;   Version:        1.0   Released 03/04/2003
;   Author:         Gary Karnes , Axiom Mfg.
;   Compiler:       HC08
;       
;   Platform:       Axiom M68EVB08GB60 AXM-0308
;   Purpose:        HEX Routines
; ============================================================================
;
; Hex convertion's 
;
; output right four bits of acc A as a hex ascii value
; send to com 1
HEXOUT:
       and   #$0f      ; mask off bits
       cmp   #$09      ; compare to number
       bhi   HEX01     ; branch if a thru f
       add   #$30      ; add standard offset
       jsr   Sci1_Out
       rts
HEX01:
       add   #$37      ; change a-f to ascii
       jsr   Sci1_Out
       rts
; output right four bits of acc A as a hex ascii value
; send to com 2
HEXOUTC2:
       and   #$0f      ; mask off bits
       cmp   #$09      ; compare to number
       bhi   HEX01C2   ; branch if a thru f
       add   #$30      ; add standard offset
       jsr   Sci2_Out
       rts
HEX01C2:
       add   #$37      ; change a-f to ascii
       jsr   Sci2_Out
       rts

; send two hex values in acc A
; send to com 1
HEX2:
       psha            ; save a
       lsra            ; shift right four places
       lsra
       lsra
       lsra
       bsr    HEXOUT   ; send high hex char
       pula            ; restore a
       and    #$0f     ; only send lower 4 bits
       bsr    HEXOUT   ; send low hex char
       rts
; send two hex values in acc A
; send to com 2
HEX2C2:
       psha            ; save a
       lsra            ; shift right four places
       lsra
       lsra
       lsra
       bsr    HEXOUTC2   ; send high hex char
       pula              ; restore a
       and    #$0f       ; only send lower 4 bits
       bsr    HEXOUTC2   ; send low hex char
       rts

; send four hex character in X register
; send to com 1
;HEX4:       
;       psha            ; save a
;       pshb            ; save b
;       pshx            ; push x on stack
;       pula            ; get high byte
;       bsr     HEX2    ; send two hex values
;       pula
;       bsr     HEX2    ; send two hex values
;       pulb            ; restore b
;       pula            ; restore a
;       rts
; send four hex character in X register
; send to com 2
;HEX4C2:       
;       psha             ; save a
;       pshb             ; save b
;       pshx             ; push x on stack
;       pula             ; get high byte
;       bsr     HEX2C2   ; send two hex values
;       pula
;       bsr     HEX2C2   ; send two hex values
;       pulb             ; restore b
;       pula             ; restore a
;       rts
;
; convert acc a to a hex value
HEXCON:
         sub     #$30    ; remove base number
         cmp     #$0A    ; if 0-9 then end
         blt     HEXI01  ;
         sub     #$07    ; convert A-F
         and     #$0f    ; remove upper case
HEXI01:  rts
;
; Buffer Input Routines
;    HEXI2C2    input 2 hex from com 2
;    HEXI2C1    input 2 hex from com 1
;
; output right four bits of acc A as a hex ascii value
; into Lcd
;HEX1LCD:
;       
;         and   #$0f      ; mask off bits
;         cmp   #$09      ; compare to number
;         bhi   HEX03     ; branch if a thru f
;         add   #$30      ; add standard offset
;         jsr   LCDBUF
;         rts
;HEX03:
;       
;         add   #$37      ; change a-f to ascii
;         jsr   LCDBUF
;         rts
; send two hex values in acc A to lcd
; 
;HEX2LCD:
;         psha              ; save acc a
;                
;         lsra              ; shift right four places
;         lsra
;         lsra
;         lsra
;         bsr    HEX1LCD    ; send high hex char to buffer
;         
;         pula              ; restore a
;         and    #$0f       ; only send lower 4 bits
;         bsr    HEX1LCD    ; send low hex char
;         rts
;
;
; send four hex in X to lcd
;HEX4LCD:
;         pshx              ; push x on stack
;         pula              ; get high byte
;         jsr    HEX2LCD    ; send 2 hex
;         pula              ; get low byte
;         jsr    HEX2LCD    ; send 2 hex
;         rts
;
;
;

