;
;
; ===========================================================================
;
;   Osc_308.asm     Axiom M68EVB08GB60 
;                                 
;   Version:        1.0   Released 01/17/2003
;   Author:         Gary Karnes , Axiom Mfg.
;   Compiler:       HC08
;       
;   Platform:       Axiom M68EVB08GB60 AXM-0308
;   Purpose:        Oscillator Control
; ============================================================================
;
; Vector table
;
;
; ICGC1 Register definition
;     Bit 0 = n/a
;         1 = IRGSTEN   0 IRG disabled, 1 IRG enabled
;         2 = OSCSTEN   0 osc disabled when ICG off, 1 osc enabled when ICG off
;       3,4 = CLKS     00=selfclocked 01=FLL engaged internal ref
;                      10=FLL bypassed ext ref,  11=FLL engaged ext ref
;         5 = REFS     0 external clk, 1 crystal
;         6 = RANGE    0 low freq P=64, 1 high freq P=1
;         7 = n/a
;
; Setup register ICGC1 for external oscillator
Osc_Ext:
            mov   #$7a,ICGC1   ; turn on external crystal

            rts
;
; Setup FLL for 16 mhz with 4Mhz crystal
Osc_16M:
            bsr   Osc_Ext      ; turn on external crystal
            mov   #$00,ICGC2   ; set FLL for 16Mhz
            bsr   Osc_Lock     ; wait for lock
;            BSR   Osc_Ext      ; turn on external crystal
            rts
;
; Setup FLL for 40Mhz
Osc_40M:
            bsr   Osc_Ext
            mov   #$30,ICGC2   ; set FLL for 40MHZ
            bsr   Osc_Lock     ; wait for lock
;            bsr   Osc_Ext
            rts
;
; Wait for lock
Osc_Lock:
            jsr   DELAY10M      ; delay
            lda   ICGS1
            BIT   #$08         ; TEST LOCK
;            beq   Osc_Lock     ; loop until locked
            jsr   DELAY10M     ; delay            
; check lock again
            lda   ICGS1
            bit   #$08
;           beq   Osc_Lock     ; loop until locked
            rts
;
;

          


