;
; ===========================================================================
;
;   Register.asm    Register Display & Control 
;                                 
;   Version:        1.0   Released 05/12/2001
;   Author:         Gary Karnes , Axiom Mfg.
;   Compiler:       As12
;       
;   Platform:       Axiom Cmd12a4
;   Purpose:        Displays Registers
; ============================================================================
;
;
; The following will Display the Registers
; and pause for key press
; call this sub-routine & registers are listed on Com 1
REGISTDP:
           pshc             ; save ccr on stack
           staa  REGISTEA   ; save acc a
           stab  REGISTEB   ; save acc b
           pula             ; get ccr
           staa  REGISCCR   ; save ccr
           stx   REGISTEX   ; save x
           sty   REGISTEY   ; save y
           pulx
           stx   REGISTPC   ; save pc
           sts   REGISTSP   ; save sp
           pshx             ; restore pc
;---display acc a
           jsr   CAR3       ; skip lines
           jsr   OUT1STR2
           fdb   M001       ; A
           fdb   M0Y0       ; =
           ldaa  REGISTEA   ; get acc a
           jsr   HEX2      ; display value
;---display acc b
           jsr   SPACE4    ; tab over
           jsr   OUT1STR2
           fdb   M01AT       ; B
           fdb   M0Y0        ; =
           ldaa  REGISTEB    ; get acc b
           jsr   HEX2        ; display value
;---display x
           jsr   SPACE4    ; tab over
           jsr   OUT1STR2
           fdb   M0XD29      ; X
           fdb   M0Y0        ; =
           ldaa  REGISTEX    ; get first byte
           jsr   HEX2
           ldaa  REGISTEX+1  ; get second byte
           jsr   HEX2        ; display x
;---display y
           jsr   SPACE4    ; tab over
           jsr   OUT1STR2
           fdb   M0XD3T      ; Y
           fdb   M0Y0        ; =
           ldaa  REGISTEY    ; get first byte
           jsr   HEX2
           ldaa  REGISTEY+1  ; get second byte
           jsr   HEX2        ; display y

;---display ccr
           jsr   CAR2
           jsr   OUT1STR2
           fdb   M029G       ; CCR
           fdb   M0Y0        ; =
           ldaa  REGISCCR    ; get ccr
           jsr   HEX2        ; display CCR

;---display pc
           jsr   CAR2
           jsr   OUT1STR2
           fdb   M0M26       ; PC
           fdb   M0Y0        ; =
           ldaa  REGISTPC    ; get first byte
           jsr   HEX2        ; display pc
           ldaa  REGISTPC+1  ; get second byte
           jsr   HEX2        ; lower half of pc
;---display sp
           jsr   SPACE4
           jsr   OUT1STR2
           fdb   M0R4DT      ; SP
           fdb   M0Y0        ; =
           ldaa  REGISTSP    ; get first byte
           jsr   HEX2        ; display upper half
           ldaa  REGISTSP+1  ; get second byte
           jsr   HEX2        ; display lower half
           
; wait for response
           jsr   BUFCLRC1    ; clear com1
           jsr   BUFRDC1     ; read com 1
; restore registers
           ldy   REGISTEY    ; get y
           ldx   REGISTEX    ; get x
           ldab  REGISTEB    ; get acc b
           ldaa  REGISCCR    ; get ccr
           pshc              ; save ccr
           ldaa  REGISTEA    ; get acc a
           pulc              ; get ccr
           rts                ; return


