;
;
; ==================================================
;
;   Sci_308.asm     Axiom M68EVB08GB60 
;                                 
;   Version:        1.0   Released 01/17/2003
;   Author:         Gary Karnes , Axiom Mfg.
;   Compiler:       HC08
;       
;   Platform:       Axiom M68EVB08GB60 AXM-0308
;   Purpose:        Serial Ports
; ==================================================
;
; Subroutines for setting up Sci ports
;
;--------------------------------------
; Input a character from Com1
;--------------------------------------
INPUT:  jsr     Receive         ; poll for char
        bcc     INPUT           ; repeat until char is received
        rts

;
;--------------------------------------
; Input a character from Com2
;--------------------------------------
INPUT2:  jsr     Receive2         ; poll for char
         bcc     INPUT2          ; repeat until char is received
         rts

;


;
;--------------------------------------
; Poll Com1 for any data in...
;--------------------------------------
Receive:
	LDA	SCI1S1		; read status
	BIT	#$20		; test if receive rdy
;      beq   Receive
	BNE	Receive1	; if true, get byte
	CLC			; clear recv flag
	RTS
Receive1:
	LDA	SCI1DRL		; READ byte
	SEC			; set recv flag
	STA	PTBD		; send byte to port B		
	
	RTS
;
;
;--------------------------------------
; Poll Com2 for any data in...
;--------------------------------------
Receive2:
	LDA	SCI2S1		; read status
	BIT	#$20		; test if receive rdy
;      beq   Receive
	BNE	ReceiveN	; if true, get byte
	CLC			; clear recv flag
	RTS
ReceiveN:
	LDA	SCI2DRL		; READ byte
	SEC			; set recv flag
	STA	PTBD		; send byte to port B		
	
	RTS
;


;
;--------------------------------------
; Sci1 Output Routine....
; example:
;          lda   #$30    ; 0
;          jsr   Sci1_Out
;--------------------------------------
Sci1_Out:
	PSHA				; Temp Save byte
Sci1_OL:
	LDA		SCI1S1		; read status
	BPL		Sci1_OL	; loop for ready to send
	PULA				; get data back
	STA		SCI1DRL		; send byte
	RTS
;
;
;--------------------------------------
; Sci2 Output Routine....
; example:
;          lda   #$30    ; 0
;          jsr   Sci1_Out
;--------------------------------------
Sci2_Out:
	PSHA				; Temp Save byte
Sci2_OL:
	LDA		SCI2S1		; read status
	BPL		Sci2_OL	; loop for ready to send
	PULA				; get data back
	STA		SCI2DRL		; send byte
	RTS
;

;
;--------------------------------------
; Transmit string...
;--------------------------------------
Send_MSG:

Send_lp:
	LDA		,X		; get byte
	INCX				; bump pointer +1
	JSR		Sci1_Out	; send byte out
	CMP		#$00		; test for end
	BNE		Send_lp   	; loop if more bytes
	RTS
;




;
; Setup Sci1 for 8 data, no parity, TE=1, RE=1
Sci1set:
           mov  #$00,SCI1C1   ; 8 DATA, NO PARITY
           MOV  #$0C,SCI1C2   ; TE=1 RE=1
           rts
;
;
; Setup Sci2 for 8 data, no parity, TE=1, RE=1
Sci2set:
           mov  #$00,SCI2C1   ; 8 DATA, NO PARITY
           MOV  #$0C,SCI2C2   ; TE=1 RE=1
           rts
;
;
; Setup baud rate for Sci1
; baud rate at 16 mhz, 8 mhz bus clock
; baud = 19200
Sci11619: 
           mov    #$00,SCI1BD       ; baud reg
           mov    #$1a,SCI1BDL      ; baud reg
           rts
;
; Setup baud rate for Sci1
; baud rate at 10.8 mhz, 5.4 mhz bus clock
Sci15496:
           mov    #$00,SCI1BD       ; baud reg
           MOV    #$23,SCI1BDL      ; baud reg
           rts
;
;
; Setup baud rate for Sci2
; baud rate at 16 mhz, 8 mhz bus clock
; baud = 19200
Sci21619: 
           mov    #$00,SCI2BD       ; baud reg
           mov    #$1a,SCI2BDL      ; baud reg
           rts
;
; Setup baud rate for Sci2
; baud rate at 10.8 mhz, 5.4 mhz bus clock
Sci25496:
           mov    #$00,SCI2BD       ; baud reg
           MOV    #$23,SCI2BDL      ; baud reg
           rts
;

;
;